package sdelatorre.carautobluetooth.com;


import java.util.Timer;
import java.util.TimerTask;

import android.bluetooth.BluetoothAdapter;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.SharedPreferences;

import android.content.Intent;
import android.os.Bundle;
import android.telephony.TelephonyManager;
public class ReceptorLlamadas extends BroadcastReceiver {
	 
    @Override
    public void onReceive(Context context, Intent intent) {
          // Sacamos informacin de la intencin
          String estado = "";
        		  //numero = "";
          Bundle extras = intent.getExtras();
     
      //indica que la app est activada    
      if (MainActivity.app)
     {          
          if (extras != null) {
        	  estado = extras.getString(TelephonyManager.EXTRA_STATE);
            
              if(estado.equals(TelephonyManager.EXTRA_STATE_IDLE)) {
            	  if (MainActivity.parada_tecnica){
              		 
              		 //CONECTA EL BLUETOOTH
              		 desconectar_bluetooth(context);
              		 //reiniciamos parada
              		 MainActivity.parada_tecnica=false;
              		 
              	 	}
             	}
                 
                if (estado.equals(TelephonyManager.EXTRA_STATE_RINGING)) {

                	// numero = extras.getString(TelephonyManager.EXTRA_INCOMING_NUMBER);
                	
                	 if (MainActivity.estado.equals("parado")){
                        	
                        SharedPreferences pref = context.getSharedPreferences("sdelatorre.carautobluetooth.com_preferences", Context.MODE_PRIVATE);
                			
                        if (pref.getBoolean("preguntarbluetooth", false)){
                				   abrir_app(context);  
                				} else{
                				desconectar_bluetooth(context);
                				MainActivity.parada_tecnica=true;
                				
                					}
                        	}
                    
                }
                 
          }
     }
   
        
        
    }

	private void desconectar_bluetooth(Context context) {
		
	
		
		BluetoothAdapter adapter = BluetoothAdapter.getDefaultAdapter(); 
		if(adapter != null) {
		    if(adapter.getState() == BluetoothAdapter.STATE_ON) {
		       adapter.disable();
		        
		    } else if (adapter.getState() == BluetoothAdapter.STATE_OFF){
		       adapter.enable();
		    
		    } else {
		    	
		    }
		    
		}
		
			}
		

	
private void abrir_app(final Context context){
	
	//timer porque no ha habido manera de que aparezca por encima de la
	//llamada 
	Timer t=new Timer();
	TimerTask t1 = new TimerTask(){
		
		public void run() {

			Intent myIntent = new Intent(context.getApplicationContext(), MainActivity.class);

			Bundle bundle = new Bundle();
			
			myIntent.putExtras(bundle);
			
			
			myIntent.setFlags(
					Intent.FLAG_ACTIVITY_NEW_TASK  
				    |Intent.FLAG_ACTIVITY_CLEAR_TOP
				    |Intent.FLAG_ACTIVITY_BROUGHT_TO_FRONT
				    );
				
		
			bundle.putString("dialog", "yes");
			context.startActivity(myIntent);
			//enviar_receptor(context,"mensaje");

			
		    	}

	
 };

 t.schedule(t1, 3000);


}

}